# MAKE A SCATTERPLOT OF TWO FEATURES WITH CLASS GIVEN BY COLOUR.  The
# two feature vectors are the first two arguments.  The vector of classes 
# (0/1) is the next argument, defaulting to train.y.  It may be shorter than
# the feature vectors, in which case the remaining cases are considered 
# unlabelled.  A jitter argument can be specified giving the amount of jitter 
# to add to the values.  Additonal arguments are passed on to the "plot"
# procedure.  The colours used are blue for class 0, red for class 1, and 
# gray for unlabelled.

plotc <- function(x1,x2,y=train.y,jitter=NULL,colours=c("blue","red","gray"),
                  pchars=list(20,20,20),xlab="",ylab="",...)
{
  if (!is.null(jitter))
  { x1 <- x1+jitter*runif(length(x1),-0.4,0.4)
    x2 <- x2+jitter*runif(length(x2),-0.4,0.4)
  }

  plot(x1,x2,type="n",xlab=xlab,ylab=ylab,...)

  if (length(y)<length(x1))
  { r <- (length(y)+1):length(x1)
    points(x1[r],x2[r],pch=pchars[[1]],col=colours[3])
  }

  points (x1[1:length(y)], x2[1:length(y)],
          col=colours[1:2][y+1], pch=c(pchars[[1]],pchars[[2]])[y+1])
}
